<?php
include 'preg_find.php'; 		// 10x to Paul Gregg <pgregg@pgregg.com> for the excellent function which saved me many troubles! :)
include('xml.php');

$bad_quotes = array("\\\"", "\\'");
$good_quotes = array("\"", "'");

$USERS = 0;
$timestamp = date("YmdHis");
function to_day($timestamp, $pattern) {
	$hour= $timestamp[8] . $timestamp[9];
	$minute = $timestamp[10] . $timestamp[11];
	$second = $timestamp[12] . $timestamp[13];
	$month  = $timestamp[4] . $timestamp[5];
	$day = $timestamp[6] . $timestamp[7];
	$year= $timestamp[0] . $timestamp[1] . $timestamp[2] . $timestamp[3];

	$today = date($pattern, mktime($hour, $minute, $second, $month, $day, $year));
	return $today;
}

function grep_users($users_db) {
	if (is_readable($users_db)) {
		if ( filesize($users_db) == 0 ) {
			return 0;
		} elseif (!$fp = fopen($users_db, 'r')) {
			echo "ERROR: Cannot open file ($users_db)";
			continue;
		} else {
			$content_of_users_db = fread($fp, filesize($users_db)) ;
		}
		fclose( $fp );
	} else {
		echo "ERROR: The file $users_db is not readable!";
		exit;
	}

	$users = preg_split('/\n/', $content_of_users_db, -1, PREG_SPLIT_NO_EMPTY);
	$USERS = count($users);
	if ($USERS < 1) {
		return 0;
	} else {
		return $users;
	}
}

function cmp($a, $b) {
	if ($a['yorder'] ==  $b['yorder']) return $a['id'] < $b['id'] ? 1 : -1;
	return $a['yorder'] < $b['yorder'] ? 1 : -1;
}

function XML_to_Array($xmlstr) {
	$xml = XML_unserialize($xmlstr);
	return $xml['entry'];
}

function file_name_is($id, $c) {
	include 'include/config.inc.php';
	$filename = $_categories_dir . $c . "/" . $id[0] . $id[1] . $id[2] . $id[3] . "/" . $id[4] . $id[5] . "/";
	$filename .=  $id[6] . $id[7] .  $id[8] . $id[9] . $id[10] . $id[11] . $id[12] . $id[13] . ".xml";
	return $filename;
}

function id_is($filename) {
	return basename(dirname(dirname($filename))) . basename(dirname($filename)) . substr(basename($filename), 0, -4);
}

function category_is($filename) {
	return basename(dirname(dirname(dirname($filename))));
}

function grep_entries($argsArray) {

	include 'include/config.inc.php';
	$files = preg_find("/\.xml$/", "$_categories_dir" , PREG_FIND_RECURSIVE);

	if (count($argsArray) == 0) { $argsArray = array("NULL" => "NULL"); }
	$is_empty=true;
	foreach ($argsArray as $id => $arg) {
		$filtered_xml = array();
		foreach ($files as $file) {
			$xml_array = XML_to_Array(file_get_contents($file));
			$xml_array['category'] = category_is($file);
			$xml_array['id'] = id_is($file);
			if ($xml_array['level'] == "0" && $xml_array['author'] != $_SESSION['username']) {
				$is_empty = false;
				continue;
			}
			switch ($id) {
				case "id":  if (id_is($file) == $arg) $filtered_xml[] = $xml_array;
				break;

				case "category":
				case "c":  if (category_is($file) == $arg) $filtered_xml[] = $xml_array; 
				break;

				case "month":
				case "m":  if (to_day($xml_array['id'], "m") == $arg) $filtered_xml[] = $xml_array; 
				break;

				case "year":
				case "y":  if (to_day($xml_array['id'], "Y") == $arg) $filtered_xml[] = $xml_array; 
				break;

				case "author":
				case "a":  if ($xml_array['author'] == $arg) $filtered_xml[] = $xml_array; 
				break;

				case "title":
				case "t":  if ($xml_array['title'] == $arg) $filtered_xml[] = $xml_array; 
				break;

				case "tag":  $tags = explode(",", $xml_array['tags']);
						foreach ($tags as $tag) if (trim($tag) == $arg) $filtered_xml[] = $xml_array;
				break;

				case "delcat": delcat($argsArray['delcat']); return; 
				break;

				case "search":
				case "s":  if ($arg != "" && stristr(strip_tags($xml_array['content']), $arg))
					$filtered_xml[] = $xml_array; 
					if ($arg != "") break;

				default: 
					if ($xml_array['index']  != "0" && count($argsArray) <= 1) 
					$filtered_xml[] = $xml_array;
			} // switch
		} // foreach
	} //  foreach
	$xml_array = $filtered_xml;

	if (count($xml_array)) {
		usort($xml_array, "cmp");
		return $xml_array;
	} elseif (count($argsArray)) {
		echo "<br/>";
		if ($_SESSION["status"] == "logged" && (isset($argsArray['c']) || isset($argsArray['category'])) && $is_empty) echo "<br/><center><font size=\"4\"><a href=\"index.php?delcat=" . $argsArray['c'] . "\">delete category " . "\"" . $argsArray['c'] . "\"" . "</a></font></center>";
	} else {
		return $xml_array;
	}
}

function get_entry($options) {
	include 'include/config.inc.php';
	$id	= $_GET['id'];
	$c	= $_GET['c'];
	return XML_to_Array(file_get_contents(file_name_is($id, $c)));
}

function delcat($cat) {
	if ($cat && $cat != "." && $cat != "..") {
		$files = preg_find("/^.*$/", $_categories_dir . "$cat",1);
		foreach ($files as $file) {
			unlink("$file");
		}
		rmdir($_categories_dir . "$cat");
	}
	header("Location: index.php");
}

function log_out() {
	$_SESSION = array("status" => "NOTlogged");
	if (isset($_COOKIE[session_name()])) setcookie(session_name(), '', time()-42000, '/');
	session_unset();
	session_destroy();
	header("Location: index.php");
}

function elliStr($s,$n) {			// 10x to jay for his function published 15-Jun-2005 06:34 on http://www.php.net/manual/en/function.substr.php
	for ( $x = 0; $x < strlen($s); $x++ ) {
		$o = ($n+$x >= strlen($s) ? $s : ($s{$n+$x} == " " ? substr($s,0,$n+$x) . "..." : ""));
		if ( $o != "" ) { return $o; }
	}
}

function is_emtpy_dir($dirname) {		// 10x to rchavezc at ameritech dot net for this function published 12-Dec-2004 05:19 on http://php.net/manual/en/function.is-dir.php#48116
	$result=false;
	if (is_dir($dirname)) {
		$result=true;
		$handle = opendir($dirname);
		while (($name = readdir($handle)) !== false) {
			if ($name!= "." && $name !="..") {
				$result=false;
				break;
			}
		}
		closedir($handle);
	}
	return $result;
}

function mkdir_r ($dir, $mode = 0755) {
	if (is_dir($dir) || @mkdir($dir,$mode)) return TRUE;
	if (!mkdir_r(dirname($dir),$mode)) return FALSE;
	return @mkdir($dir,$mode);
}

function browser_warning($style) {
	if (stristr($_SERVER['HTTP_USER_AGENT'], 'msie')) {
		if (!stristr($style,'nongecko')) $style = 'surgery-nongecko.css'; 
	}
	return $style;
}
?>
