<?
/*
 * Set the language on one language. Else, htprotector tries to read the
 * language setting of the browser. If this fails, HTP_LANG_BACKUP is used.
 * Example: define ( "HTP_LANG", "de" );
 */
//define ( "HTP_LANG", "en" );
define ( "HTP_LANG_BACKUP", "en" );

/*
 * Path for .htaccess and .htpasswd files.
 * Default: location of this script.
 */
// echo "<br /><pre>";
// print_r($_SERVER);
// echo "</pre>";
define ( "HT_PATH", dirname ( $_SERVER['PATH_TRANSLATED'] ) );
/*
   Location and name of .htaccess file.
   Default: location of this script and file name ".htaccess"
*/ 
define ( "HTACCESS", HT_PATH."/.htaccess" );
/*
   Location and name of .htpasswd file.
   Default: location of this script and file name ".htpasswd"
*/ 
define ( "HTPASSWD", HT_PATH."/.htpasswd" );

/*
 * Language settings
 *
 * If you translated those texts into your language or corrected
 * any typos, then send this to me and/ or open a request:
 * https://sourceforge.net/tracker/?group_id=112890&atid=683439
 *
 * Thanks!
 *
 */
$lang['en']['title'] = "Protected Area";
$lang['en']['html_title'] = "Access List Administration";
$lang['en']['html_username'] = "Username";
$lang['en']['html_password'] = "Password";
$lang['en']['html_email'] = "EMail";
$lang['en']['html_submit'] = "Create User/Password";
$lang['en']['html_userlist'] = "Userlist";
$lang['en']['html_delete'] = "delete user";
$lang['en']['html_is_admin'] = "Administrator";
$lang['en']['html_version_warning'] = "A newer version of HTprotector is available. <a href=\"http://sourceforge.net/projects/htprotector/\">Please update your script</a>";
$lang['en']['email_subject'] = "Password for ".$lang['en']['title'];
$lang['en']['email_intro'] =
	"Hello!\n\nHere are your authentication informations for the page "
	."http://".$_SERVER['SERVER_NAME'].substr
	(
		$_SERVER['PHP_SELF'],
		0,
		strlen ( $_SERVER['PHP_SELF'] ) - strlen ( basename( $_SERVER['PHP_SELF'] ) )
	)
	." : \n\n";
$lang['en']['email_extro'] = "\n\n--\n\nAutomated mail send by htprotector ".HTP_VERSION." by Manuel Hoppe\nVisit http://sourceforge.net/projects/htprotector/ for more information.\n\n"
;
$lang['en']['html_deny'] = 
	"<p>Please enter the valid login ID and password to access the\n"
	."Protector access manager.</p>\n"
	."<p>If you are the webmaster of this site and don't know why\n"
	."you get this error message, edit the file\n"
	."\"".$_SERVER['PHP_SELF']."\" and read <b>carefully</b> the comment above\n"
	."the HTP_ADMIN define.</p>\n";

$lang['de']['title'] = "Gesch&uuml;tzter Bereich";
$lang['de']['html_title'] = "Zugriffsverwaltung";
$lang['de']['html_username'] = "Benutzername";
$lang['de']['html_password'] = "Passwort";
$lang['de']['html_email'] = "EMail";
$lang['de']['html_submit'] = "Benutzer/Passwort anlegen";
$lang['de']['html_userlist'] = "Benutzerliste";
$lang['de']['html_delete'] = "Benutzer l&ouml;schen";
$lang['de']['html_is_admin'] = "Verwalter";
$lang['de']['html_version_warning'] = "Eine neue Version des HTprotector ist verf&uuml;gbar. <a href=\"http://sourceforge.net/projects/htprotector/\">Bitte aktualisieren Sie dieses Skript.</a>";
$lang['de']['email_subject'] = "Passwort f&uuml;r ".$lang['de']['title'];
$lang['de']['email_intro'] =
	"Sehr geehrte Damen und Herren,\n\nhiermit erhalten Sie zu Zugangsdaten fr die Seite "
	."http://".$_SERVER['SERVER_NAME'].substr
	(
		$_SERVER['PHP_SELF'],
		0,
		strlen ( $_SERVER['PHP_SELF'] ) - strlen ( basename( $_SERVER['PHP_SELF'] ) )
	)
	." : \n\n";
$lang['de']['email_extro'] = "\n\n--\n\nAutomatisierte Mail gesendet von htprotector ".HTP_VERSION." (Autor: Manuel Hoppe)\nN&auml;here Informationen unter http://sourceforge.net/projects/htprotector/.\n\n"
;
$lang['de']['html_deny'] = 
	"<p>Bitte geben Sie einen g&uml;ltige Benutzername und Passwort fr den geschtzen Bereich.</p>\n"
	."<p>Wenn Sie der Verwalter dieser Seite sind und nicht wissen warum diese Meldung kommt, dann\n"
	."schauen Sie bitte in die Datei\n"
	."\"".$_SERVER['PHP_SELF']."\" und lesen aufmerksam den Kommentar ber der HTP_ADMIN Definition.</p>\n";


/*
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 *
 *
 *              NO CHANGES NEEDED BEYOND THIS POINT!
 *
 *
 *
 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 */

if ( strlen ( $lang[HTP_LANG_BACKUP]['html_title'] ) == 0 )
{
	// This is the very last backup language setting...
	define ( "HTP_LANG", "en" );
}
else
{
	define ( "HTP_LANG", HTP_LANG_BACKUP );
}

define ( "HTTITLE", $lang[HTP_LANG]['title'] );
define ( "HTML_TITLE", $lang[HTP_LANG]['html_title'] );
define ( "HTML_USERNAME", $lang[HTP_LANG]['html_username'] );
define ( "HTML_PASSWORD", $lang[HTP_LANG]['html_password'] );
define ( "HTML_EMAIL", $lang[HTP_LANG]['html_email'] );
define ( "HTML_SUBMIT", $lang[HTP_LANG]['html_submit'] );
define ( "HTML_USERLIST", $lang[HTP_LANG]['html_userlist'] );
define ( "HTML_DELETE", $lang[HTP_LANG]['html_delete'] );
define ( "HTML_IS_ADMIN", $lang[HTP_LANG]['html_is_admin'] );
define ( "EMAIL_SUBJECT", $lang[HTP_LANG]['email_subject'] );
define ( "EMAIL_INTRO",	$lang[HTP_LANG]['email_intro'] );
define ( "EMAIL_EXTRO", $lang[HTP_LANG]['email_extro'] );
define ( "HTDENY", $lang[HTP_LANG]['html_deny'] );

function generate_password ( $length = 8 )
{
        $valid_pool = "abcdefghkmnpqrstuvwxyzABCDEFGHKLMNPQRSTUVWXYZ123456789";
        mt_srand( ( double ) microtime () * 1000000 );
        for ( $i = 0; $i < $length; $i++ )
        {
                $value = mt_rand ( 0, ( strlen ( $valid_pool ) - 1 ) );
                $password = $password.$valid_pool[$value];
        }
        return $password;
}

function rewrite_htpasswd ( $userlist )
{
	if ( count ( $userlist ) == 0 && strlen ( HTP_KEEP ) > 0 )
	{
		unlink ( HTACCESS );
		unlink ( HTPASSWD );
	}
	else
	{
		$handle = fopen ( HTPASSWD, "w+" );
		for ( $i = 0; $i < count ( $userlist ); $i++ )
		{
			fwrite ( $handle, $userlist[$i]["name"].":".$userlist[$i]["crypted"]."\n" );
		}
		fclose ( $handle );
	}
}

function is_in_userlist ( $username, $userlist )
{
	$result = false;
	if ( strlen ( $userlist ) > 0 )
	{
		$userlist = explode ( ",", $userlist );
		for ( $i = 0; $i < count ( $userlist ) && !$result; $i++ )
		{
			if ( $username == trim ( $userlist[$i] ) )
			{
				$result = true;
			}
		}
	}
	return $result;
}
if
(
	defined ( "HTP_ADMIN" )
	&& !is_in_userlist ( $_SERVER['PHP_AUTH_USER'], HTP_ADMIN )
)
{
	Header( "WWW-Authenticate: Basic realm=\"".HTTITLE."\"");
	Header( "HTTP/1.0 401 Unauthorized");
	echo ( "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n" );
	echo ( "<html>\n" );
	echo ( "<head>\n" );
	echo ( "<title>\n" );
	echo ( HTML_TITLE."\n" );
	echo ( "</title>\n" );
	if ( defined ( "HTP_FAVICON" ) )
	{
		echo ( "<link rel=\"shortcut icon\" href=\"".HTP_FAVICON."\" />\n" );
	}
	if ( defined ( "HTP_STYLESHEET" ) )
	{
		echo ( "<link rel=\"stylesheet\" href=\"".HTP_STYLESHEET."\" />\n" );
	}
	echo ( "</head>\n" );
	echo ( "<body>\n" );
	echo ( "<h1>\n" );
	echo ( HTML_TITLE."\n" );
	echo ( "</h1>\n" );
	echo ( HTDENY );
	die ();
}

$action = $_REQUEST['action'];
$username = $_REQUEST['username'];
$password = $_REQUEST['password'];
$email = $_REQUEST['email'];

/*
   If $action is "edit", create or edit a new authentication
*/
if ( $action == "edit" )
{
	if ( strlen ( $password ) == 0 )
	{
		$password = generate_password ();
	}
	if ( is_readable ( HTPASSWD ) )
	{
		/*
		   Search for existing user
		*/
		$searchlist = get_userlist ();
		$edited = false;
		for ( $i = 0; $i < count ( $searchlist ); $i++ )
		{
			if ( $searchlist[$i]["name"] == $username )
			{
				$edited = true;
				$searchlist[$i]["crypted"] = crypt ( $password );
			}
		}
		/*
		   Create new user
		*/
		if ( !$edited )
		{
			$searchlist[$i]["name"] = $username;
			$searchlist[$i]["crypted"] = crypt ( $password );
		}
	}
	else
	{
		/*
		   Create new user in new file
		*/
		$searchlist[0]["name"] = $username;
		$searchlist[0]["crypted"] = crypt ( $password );
	}
	rewrite_htpasswd ( $searchlist );
	/*
	   Send notification if $email is set
	*/
	if ( strlen ( $email ) > 0 )
	{
		$message = EMAIL_INTRO
			.HTML_USERNAME.": ".$username."\n"
			.HTML_PASSWORD.": ".$password."\n"
			.EMAIL_EXTRO;
		unset ( $header );
		if ( defined ( "HTP_ADMIN_EMAIL" ) )
		{
			$adm_email = HTP_ADMIN_EMAIL;
		}
		else
		{
			$adm_email = $_SERVER["SERVER_ADMIN"];
		}
		$header = "From:".$adm_email."\r\n"
			."Reply-To: ".$adm_email."\r\n"
			."X-Mailer: htprotector ".HTP_VERSION."\r\n"
			."X-Remote-IP: ".$_SERVER["REMOTE_ADDR"]."\r\n"
			."X-Create-User: ".$_SERVER['PHP_AUTH_USER'];
		mail ( $email, EMAIL_SUBJECT, $message, $header );
	}
}

if
(
	$action == "delete"
	&& strlen ( $username ) > 0
	&& !is_in_userlist ( $username, HTP_NO_DEL_USER )
)
{
	$searchlist = get_userlist ();
	$j = 0;
	for ( $i = 0; $i < count ( $searchlist ); $i++ )
	{
		if ( $searchlist[$i]["name"] != $username )
		{
			$newlist[$j]["name"] = $searchlist[$i]["name"];
			$newlist[$j]["crypted"] = $searchlist[$i]["crypted"];
			$j++;
		}
	}
	rewrite_htpasswd ( $newlist );
}

unset ( $action );
unset ( $username );
unset ( $password );
unset ( $email );

/*
   If exists, open .htpasswd and read all usernames
*/
if ( is_readable ( HTPASSWD ) )
{
	if ( ! is_readable ( HTACCESS ) )
	{
		unset ( $tmp );
		$tmp = fopen ( HTACCESS, "a" );
		fwrite ( $tmp, HTACCESS_CONTENT );
		unset ( $tmp );
	}
	$userlist = get_userlist ();
}

if ( strlen ( $password ) == 0 )
{
	$password = generate_password ();
}

/*
echo ( "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n" );
echo ( "<html>\n" );
echo ( "<head>\n" );
echo ( "<title>\n" );
echo ( HTML_TITLE."\n" );
echo ( "</title>\n" );
if ( defined ( "HTP_FAVICON" ) )
{
	echo ( "<link rel=\"shortcut icon\" href=\"".HTP_FAVICON."\" />\n" );
}
if ( defined ( "HTP_STYLESHEET" ) )
{
	echo ( "<link rel=\"stylesheet\" href=\"".HTP_STYLESHEET."\" />\n" );
}
echo ( "</head>\n" );
echo ( "<body>\n" );
*/

echo ( "<p>\n" );
echo ( "<div align=\"right\">\n" );
echo ( "<small>" );
echo ( "htprotector ".HTP_VERSION." by <a href=\"mailto:m.hoppe@hyperspeed.de\">Manuel Hoppe</a> " );
echo ( "Visit <a href=\"http://sourceforge.net/projects/htprotector/\">http://sourceforge.net/projects/htprotector/</a> for more information and updates.<br />" );
echo ( "</small>" );
echo ( "</div>\n" );
echo ( "</p>\n" );

echo ( "<hr class=\"line\" \>" );

echo ( "<p>\n" );
echo ( "<form method=\"post\">\n" );
echo ( "<input name=\"action\" type=\"hidden\" value=\"edit\" />\n" );
echo ( "<table>\n" );
echo ( "<tr>\n" );
echo ( "<td><input class=\"input\" name=\"username\" type=\"text\" size=\"16\" maxlength=\"16\" /></td>\n" );
echo ( "<td><div class=\"required\">:".HTML_USERNAME."</div></td>\n" );
// echo ( "<td rowspan=\"2\"><input class=\"button\" type=\"submit\" value=\" ".HTML_SUBMIT." \"></td>\n" );
echo ( "</tr>\n" );
echo ( "<tr>\n" );
echo ( "<td><input class=\"input\" name=\"password\" type=\"text\" size=\"16\" maxlength=\"16\" value=\"".$password."\" /></div></td>\n" );
echo ( "<td><div class=\"required\">:".HTML_PASSWORD."</div></td>\n" );
echo ( "</tr>\n" );
echo ( "</table>") ;
echo ( "<input class=\"button\" type=\"submit\" value=\" ".HTML_SUBMIT." \"> for the following directories:<br /><br />\n" );
echo ( "<input type=\"checkbox\" name=\"db\" > db/ (highly recommended)<br />\n" );
echo ( "<input type=\"checkbox\" name=\"include\" > include/<br />\n" );
echo ( "<input type=\"checkbox\" name=\"modules\" > modules/<br />\n" );
echo ( "</form>\n" );
echo ( "</p>\n" );

/*
echo ( "<br />\n" );
echo ( "<p>\n" );
echo ( HTML_USERLIST.":<br />\n" );
echo ( "<ul>\n" );
for ( $i = 0; $i < count ( $userlist ); $i++ )
{
	echo ( "<li>\n" );
	echo ( $userlist[$i]["name"] );
	if ( !is_in_userlist ( $userlist[$i]["name"], HTP_NO_DEL_USER ) )
	{
		echo ( " (<a href=\"".$PHP_SELF."?action=delete&username=".$userlist[$i]["name"]."\">".HTML_DELETE."</a>)" );
	}
	if ( is_in_userlist ( $userlist[$i]["name"], HTP_ADMIN ) )
	{
		echo ( " (".HTML_IS_ADMIN.")" );
	}
	echo ( "\n" );
	echo ( "</li>\n" );
}
if ( count ( $userlist ) == 0 )
{
	echo ( "<li>\n" );
	echo ( "-\n" );
	echo ( "</li>\n" );
}
echo ( "</ul>\n" );
echo ( "</p>\n" );
echo ( "</body>\n" );
echo ( "</html>\n" );
*/
?>
